---
title: XRInputSource.targetRayMode
slug: Web/API/XRInputSource/targetRayMode
tags:
  - API
  - AR
  - Pointing
  - Property
  - Ray
  - Read-only
  - Reference
  - VR
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSource
  - direction
  - pointer
  - target
  - targetRayMode
---
<p>{{APIRef("WebXR")}}{{securecontext_header}}</p>

<p>The read-only {{domxref("XRInputSource")}} property <strong><code>targetRayMode</code></strong> indicates the method by which the target ray for the input source should be generated and how it should be presented to the user.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">let <em>rayMode</em> = <em>xrInputSource</em>.targetRayMode;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} taken from the {{domxref("XRTargetRayMode")}} enumerated type, indicating which method to use when generating and presenting the target ray to the user. The possible values are:</p>

<p>{{page("/en-US/docs/Web/API/XRTargetRayMode", "Values")}}</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>The input source's {{domxref("XRInputSource.targetRaySpace", "targetRaySpace")}} indicates the position and orientation of the target ray, and can be used to determine where to render the ray.</p>

<h2 id="Example">Example</h2>

<p>{{page("/en-US/docs/Web/API/XRTargetRayMode", "Examples")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrinputsource-targetraymode','XRInputSource.handedness')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.XRInputSource.targetRayMode")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a></li>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a></li>
 <li><a href="/en-US/docs/Web/WebXR%20Device%20API/Gamepads">Using gamepads in WebXR applications</a></li>
</ul>
